package net.example.app;

import java.io.IOException;
import java.util.Hashtable;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import net.example.ejb.Greeter;

public class AppServiceServlet extends HttpServlet
{

	private static final long serialVersionUID = 1L;

	@Override
	public void init() throws ServletException
	{
		super.init();
		System.out.println("Initializing services...");
		start();
	}

	@Override
	protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException
	{
		System.out.println("Listing services...");
	}

	private void start()
	{
		AppService service = new AppService("userx", "userx");
		new Thread(service).start();
	}

	public class AppService implements Runnable
	{
		private String username;
		private String password;
		private InitialContext context;

		public AppService(String username, String password)
		{
			this.username = username;
			this.password = password;
			setup();
		}

		@Override
		public void run()
		{
			invoke("java:global/test/test.jar/net.example.ejb.GreeterBean!net.example.ejb.Greeter");
			invoke("java:app/test.jar/net.example.ejb.GreeterBean!net.example.ejb.Greeter");
			invoke("java:module/net.example.ejb.GreeterBean!net.example.ejb.Greeter");
			invoke("java:jboss/exported/test/test.jar/net.example.ejb.GreeterBean!net.example.ejb.Greeter");
			invoke("java:global/test/test.jar/net.example.ejb.GreeterBean!net.example.ejb.GreeterBean");
			invoke("java:app/test.jar/net.example.ejb.GreeterBean!net.example.ejb.GreeterBean");
			invoke("java:module/net.example.ejb.GreeterBean!net.example.ejb.GreeterBean");
			invoke("java:jboss/exported/test/test.jar/net.example.ejb.GreeterBean!net.example.ejb.GreeterBean");
		}

		private void setup()
		{
			// tested with and without URL_PKG_PREFIXES and INITIAL_CONTEXT_FACTORY
			Hashtable<String, String> properties = new Hashtable<String, String>();
//			properties.put(Context.URL_PKG_PREFIXES, "org.jboss.ejb.client.naming");
//			properties.put(Context.INITIAL_CONTEXT_FACTORY, "org.jboss.as.naming.InitialContextFactory");
			properties.put(Context.SECURITY_PRINCIPAL, username);
			properties.put(Context.SECURITY_CREDENTIALS, password);

			try
			{
				context = new InitialContext(properties);
			}
			catch(NamingException e)
			{
				throw new RuntimeException(e);
			}
		}

		private void invoke(String name)
		{
			try
			{
				//Greeter greeter = (Greeter)context.lookup("test/test/GreeterBean!net.example.ejb.Greeter");
				Greeter greeter = (Greeter)context.lookup(name);
				System.out.println(greeter.greet("userx"));
			}
			catch(Exception e)
			{
				System.err.println(e.getMessage());
			}
		}
	}
}
